package com.kingdee.eas.custom.dormitorysystem.application.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.*;
import com.kingdee.eas.custom.dormitorysystem.dormitory.DormitoryInfo;
import com.kingdee.eas.custom.dormitorysystem.occupants.IOccupants;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsCollection;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsFactory;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.affair.AffairBizException;
import com.kingdee.eas.hr.base.HRBaseException;
import com.kingdee.eas.hr.base.HRBillBaseInfo;
import com.kingdee.eas.hr.base.HRBillStateEnum;
import com.kingdee.shr.base.syssetting.BaseItemException;
import com.kingdee.shr.base.syssetting.IMSFServiceFacade;
import com.kingdee.shr.base.syssetting.MSFServiceFacadeFactory;
import com.kingdee.util.StringUtils;
import org.apache.log4j.Logger;

import java.text.SimpleDateFormat;
import java.util.*;

public class CheckoutApplicationControllerBean extends AbstractCheckoutApplicationControllerBean {
    private static Logger logger = Logger.getLogger(CheckoutApplicationControllerBean.class);

    /**
     * У鵥ݣʹã
     *
     * @param ctx
     * @param billID
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected boolean _validateBillInProcess(
            Context ctx,
            BOSUuid billID
    ) throws BOSException, EASBizException {
        boolean isError = super._validateBillInProcess(ctx, billID);
        if (!isError) {
            if (billID == null) {
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪ!"});
            }
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("*");
            sic.add("entrys.*");
            sic.add("entrys.occupants.*");
            //У鵥
            CheckoutApplicationInfo info = getCheckoutApplicationInfo(ctx, new ObjectUuidPK(billID), sic);
            try {
                HRBillStateEnum billState = info.getBillState();
                if (HRBillStateEnum.AUDITED.equals(billState)) {
                    throw new BOSException("Ѿͨظ");
                }
                IRoomChangeApplicationEntry iRoomChangeApplicationEntry = RoomChangeApplicationEntryFactory.getLocalInstance(ctx);
                CheckoutApplicationEntryCollection entrys = info.getEntrys();
                for (int i = 0; i < entrys.size(); i++) {
                    CheckoutApplicationEntryInfo entryInfo = entrys.get(i);
                    OccupantsInfo occupants = entryInfo.getOccupants();
                    if (occupants == null) {
                        throw new BOSException("סϢΪ!");
                    }
                    String personName = entryInfo.getPerson().getName();
                    //УסϢǷ񱻻
                    RoomChangeApplicationEntryCollection roomChangeApplicationEntryCollection =
                            iRoomChangeApplicationEntry.getRoomChangeApplicationEntryCollection("select parent.number where oldOccupants = '" + occupants.getId() + "'");
                    if (roomChangeApplicationEntryCollection.size() > 0) {
                        RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = roomChangeApplicationEntryCollection.get(0);
                        String number = roomChangeApplicationEntryInfo.getParent().getNumber();
                        throw new BOSException("Ա " + personName + "л޵[ " + number + " ]ύЧ\n");
                    }
                }
            } catch (Exception e) {
                logger.error(e);
                SelectorItemCollection updateSic = new SelectorItemCollection();
                sic.add("errorMsg");
                //УϢ
                info.setErrorMsg(e.getMessage());
                updatePartial(ctx, info, updateSic);
                return true;
            }
        }
        return isError;
    }


    @Override
    protected void _setSubmited(Context ctx, BOSUuid billID) throws BOSException, EASBizException {
        super._setSubmited(ctx, billID);
        //մϢ
        CheckoutApplicationInfo info = getCheckoutApplicationInfo(ctx, new ObjectUuidPK(billID));
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("errorMsg");
        //УϢ
        info.setErrorMsg(null);
        updatePartial(ctx, info, sic);
    }


    @Override
    protected void _setAuditing(Context ctx, BOSUuid billID) throws BOSException, EASBizException {
        super._setAuditing(ctx, billID);
        //մϢ
        CheckoutApplicationInfo info = getCheckoutApplicationInfo(ctx, new ObjectUuidPK(billID));
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("errorMsg");
        //УϢ
        info.setErrorMsg(null);
        updatePartial(ctx, info, sic);
    }

    /**
     * ͨ
     * е
     *
     * @param ctx
     * @param billID
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _setAudited(Context ctx, BOSUuid billID) throws BOSException, EASBizException {
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("entrys.*");
        sic.add("entrys.occupants.*");
        //У鵥
        CheckoutApplicationInfo info = getCheckoutApplicationInfo(ctx, new ObjectUuidPK(billID), sic);
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        CoreBaseCollection updateCols = new CoreBaseCollection();
        CheckoutApplicationEntryCollection entrys = info.getEntrys();
        for (int i = 0; i < entrys.size(); i++) {
            CheckoutApplicationEntryInfo entryInfo = entrys.get(i);
            Date checkoutDate = entryInfo.getCheckoutDate();
            OccupantsInfo occupants = entryInfo.getOccupants();
            occupants.setCheckOutDate(checkoutDate);
            updateCols.add(occupants);
        }
        //סϢ
        iOccupants.updateBatchData(updateCols);
        super._setAudited(ctx, billID);
    }


    @Override
    protected IObjectPK _save(Context ctx, IObjectValue model) throws BOSException, EASBizException {
        //޵
        CheckoutApplicationInfo info = (CheckoutApplicationInfo) model;
        //޵¼
        CheckoutApplicationEntryCollection entrys = info.getEntrys();
        Set<String> occupantsIds = new HashSet<String>();
        ICheckoutApplicationEntry iCheckoutApplicationEntry = CheckoutApplicationEntryFactory.getLocalInstance(ctx);
        for (int i = 0; i < entrys.size(); i++) {
            CheckoutApplicationEntryInfo checkoutApplicationEntryInfo = entrys.get(i);
            BOSUuid id = checkoutApplicationEntryInfo.getId();
            //סԱϢ
            OccupantsInfo occupants = checkoutApplicationEntryInfo.getOccupants();
            if (occupants == null) {
                throw new BOSException("סԱϢΪ!");
            }
            String occupantsId = occupants.getId().toString();
            if (occupantsIds.contains(occupantsId)) {
                throw new BOSException("дڶͬסϢ鵥Ϣ");
            }
            occupantsIds.add(occupantsId);
            //УǷڶͬסϢ޵޵¼
            FilterInfo filterInfo = new FilterInfo();
            FilterItemCollection filterItems = filterInfo.getFilterItems();
            filterItems.add(new FilterItemInfo("occupants", occupantsId));
            if (id != null) {
                filterItems.add(new FilterItemInfo("id", id, CompareType.NOTEQUALS));
            }
            SelectorItemCollection sic = new SelectorItemCollection();
            sic.add("person.name");
            sic.add("occupants.number");
            sic.add("parent.number");
            EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, sic, null);
            CheckoutApplicationEntryCollection checkoutApplicationEntryCol = iCheckoutApplicationEntry.getCheckoutApplicationEntryCollection(viewInfo);
            for (int j = 0; j < checkoutApplicationEntryCol.size(); j++) {
                CheckoutApplicationEntryInfo checkoutApplicationEntry = checkoutApplicationEntryCol.get(j);
                String personName = checkoutApplicationEntry.getPerson().getName();
                String occupantsNumber = checkoutApplicationEntry.getOccupants().getNumber();
                String number = checkoutApplicationEntry.getParent().getNumber();
                throw new BOSException(personName + "סϢ[" + occupantsNumber + "]Ѿ޵[" + number + "]ظύ޵");
            }
        }
        return super._save(ctx, model);
    }

    /**
     * ɾ
     *
     * @param ctx
     * @param pk
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _delete(Context ctx, IObjectPK pk) throws BOSException, EASBizException {
        HRBillBaseInfo info = (HRBillBaseInfo) this._getValue(ctx, pk);
        HRBillStateEnum billState = info.getBillState();
        boolean isRemovable = true;
        //ύСͨĵݲɾ
        if (HRBillStateEnum.SUBMITED.equals(billState)
                || HRBillStateEnum.AUDITING.equals(billState)
                || HRBillStateEnum.AUDITED.equals(billState)) {
            isRemovable = false;
        }
        if (!isRemovable) {
            throw new AffairBizException(AffairBizException.BILLCANTDELETE);
        }
        super._delete(ctx, pk);
    }


    /**
     * ύЧ
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _submitEffect(Context ctx, String billId) throws BOSException, EASBizException {
        if (StringUtils.isEmpty(billId)) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"idΪ!"});
        }
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("entrys.*");
        sic.add("entrys.occupants.*");
        //У鵥
        CheckoutApplicationInfo info = getCheckoutApplicationInfo(ctx, new ObjectUuidPK(billId), sic);
        HRBillStateEnum billState = info.getBillState();
        if (HRBillStateEnum.AUDITED.equals(billState)) {
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"Ѿͨظ"});
        }
        IRoomChangeApplicationEntry iRoomChangeApplicationEntry = RoomChangeApplicationEntryFactory.getLocalInstance(ctx);
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        CoreBaseCollection updateCols = new CoreBaseCollection();
        CheckoutApplicationEntryCollection entrys = info.getEntrys();
        for (int i = 0; i < entrys.size(); i++) {
            CheckoutApplicationEntryInfo entryInfo = entrys.get(i);
            Date checkoutDate = entryInfo.getCheckoutDate();
            OccupantsInfo occupants = entryInfo.getOccupants();
            if (occupants == null) {
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"סϢΪ!"});
            }
            String personName = entryInfo.getPerson().getName();
            //УסϢǷ񱻻
            RoomChangeApplicationEntryCollection roomChangeApplicationEntryCollection =
                    iRoomChangeApplicationEntry.getRoomChangeApplicationEntryCollection("select parent.number where oldOccupants = '" + occupants.getId() + "'");
            if (roomChangeApplicationEntryCollection.size() > 0) {
                RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = roomChangeApplicationEntryCollection.get(0);
                String number = roomChangeApplicationEntryInfo.getParent().getNumber();
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"Ա " + personName + "л޵[ " + number + " ]ύЧ\n"});
            }
            occupants.setCheckOutDate(checkoutDate);
            updateCols.add(occupants);
        }
        //סϢ
        iOccupants.updateBatchData(updateCols);
        //ύЧ
        IObjectPK iObjectPK = super._submitEffect(ctx, info);
        return iObjectPK;
    }

    /**
     * ύЧ
     *
     * @param ctx
     * @param model
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _submitEffect(
            Context ctx,
            CoreBaseInfo model
    ) throws BOSException, EASBizException {
        String billId = model.getId().toString();
        return _submitEffect(ctx, billId);
    }

    /**
     * 
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _untiCheckBizBill(
            Context ctx,
            String billId
    ) throws BOSException, EASBizException {
        SelectorItemCollection sic = new SelectorItemCollection();
        sic.add("*");
        sic.add("entrys.*");
        sic.add("entrys.person.*");
        sic.add("entrys.occupants.*");
        sic.add("entrys.currentRoom.*");
        CheckoutApplicationInfo info = getCheckoutApplicationInfo(ctx, new ObjectUuidPK(billId), sic);
        HRBillStateEnum billState = info.getBillState();
        if (!HRBillStateEnum.AUDITED.equals(billState)) {
            throw new AffairBizException(HRBaseException.BILLSTATECANUNCHECK);
        }
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        CheckoutApplicationEntryCollection entrys = info.getEntrys();
        CoreBaseCollection updateCols = new CoreBaseCollection();
        for (int i = 0; i < entrys.size(); i++) {
            //޵¼
            CheckoutApplicationEntryInfo entryInfo = entrys.get(i);
            PersonInfo person = entryInfo.getPerson();
            String personId = person.getId().toString();
            //ס
            Date checkInDate = entryInfo.getCheckInDate();
            if (checkInDate == null) {
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"סΪ!"});
            }
            //ԭ
            Date oldCheckoutDate = entryInfo.getOldCheckoutDate();
            if (oldCheckoutDate == null) {
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"ԭΪ!"});
            }
            OccupantsInfo occupants = entryInfo.getOccupants();
            if (occupants == null) {
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"סϢΪ!"});
            }
            //String occupantsId = occupants.getId().toString();
            //ס
            DormitoryInfo currentRoom = entryInfo.getCurrentRoom();
            if (currentRoom == null) {
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"סΪ!"});
            }
            String roomId = currentRoom.getId().toString();
            //1.У鷿ԭסڼûбס
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            Map<String, List> paramAll = new HashMap<String, List>();
            Map<String, String> params = new HashMap<String, String>();
            List list = new ArrayList();
            list.add(params);
            params.put("checkInDate", sdf.format(checkInDate));
            params.put("checkoutDate", sdf.format(oldCheckoutDate));
            params.put("personId", personId);
            params.put("roomId", roomId);
            paramAll.put("validateData", list);
            Map result = null;
            try {
                IMSFServiceFacade imsfServiceFacade = MSFServiceFacadeFactory.getLocalInstance(ctx);
                result = (Map) imsfServiceFacade.processService("validateRoomAvailableService", paramAll);
            } catch (Exception e) {
                logger.error(e);
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{"ýӿvalidateRoomAvailableService: " + e.getMessage()});
            }
            Integer code = (Integer) result.get("code");
            if (500 == code) {
                throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{(String) result.get("errorMsg").toString()});
            }
            //ûˮϸĿԷ
            occupants.setCheckOutDate(oldCheckoutDate);
            updateCols.add(occupants);
        }
        super._untiCheckBizBill(ctx, billId);
        if (updateCols.size() > 0) {
            //סϢ
            iOccupants.updateBatchData(updateCols);
        }
    }

    /**
     * У鷿ԭסڼûбס
     *
     * @param ctx
     * @param roomId
     * @param occupantsId
     * @param displayName
     * @param checkInDate
     * @param oldCheckoutDate
     * @throws BOSException
     * @throws BaseItemException
     */
    private void verifyOccupants(
            Context ctx,
            String roomId,
            String occupantsId,
            String displayName,
            Date checkInDate,
            Date oldCheckoutDate
    ) throws BOSException, BaseItemException {
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        FilterInfo filterInfo = new FilterInfo();
        FilterItemCollection filterItems = filterInfo.getFilterItems();
        filterItems.add(new FilterItemInfo("Dormitory", roomId));
        //ססں֮
        filterItems.add(new FilterItemInfo("CheckInDate", checkInDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("CheckOutDate", checkInDate, CompareType.GREATER_EQUALS));
        //ססں֮
        filterItems.add(new FilterItemInfo("CheckInDate", checkInDate, CompareType.GREATER_EQUALS));
        filterItems.add(new FilterItemInfo("CheckInDate", oldCheckoutDate, CompareType.LESS_EQUALS));
        filterItems.add(new FilterItemInfo("id", occupantsId, CompareType.NOTEQUALS));
        filterInfo.setMaskString("#0 and ((#1 and #2) or (#3 and #4)) and #5");
        SelectorItemCollection occupantsSic = new SelectorItemCollection();
        occupantsSic.add("person.name");
        EntityViewInfo viewInfo = EntityViewInfo.getInstance(filterInfo, occupantsSic, null);
        OccupantsCollection occupantsCollection = iOccupants.getOccupantsCollection(viewInfo);
        for (int j = 0; j < occupantsCollection.size(); j++) {
            OccupantsInfo occupantsInfo = occupantsCollection.get(j);
            String personName = occupantsInfo.getPerson().getName();
            throw new BaseItemException(BaseItemException.CUSTOM_EXCEPTION, new Object[]{
                    "סϢԱ[" + personName + "]" + sdf.format(checkInDate) + " ~ " + sdf.format(oldCheckoutDate) + "ڼס[" + displayName + "]޷޵"});

        }
    }
}