package com.kingdee.eas.custom.dormitorysystem.application.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.ctrl.reportone.data.framework.bos.BosUtil;
import com.kingdee.bos.dao.IObjectCollection;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.dao.IObjectValue;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.metadata.entity.*;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.eas.base.codingrule.CodingRuleManagerFactory;
import com.kingdee.eas.base.codingrule.ICodingRuleManager;
import com.kingdee.eas.basedata.org.CtrlUnitFactory;
import com.kingdee.eas.basedata.org.ICtrlUnit;
import com.kingdee.eas.basedata.org.OrgUnitInfo;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.dormitorysystem.application.*;
import com.kingdee.eas.custom.dormitorysystem.occupants.IOccupants;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsCollection;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsFactory;
import com.kingdee.eas.custom.dormitorysystem.occupants.OccupantsInfo;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.framework.Result;
import com.kingdee.shr.ats.web.util.NumberCodeRule;
import com.kingdee.shr.base.syssetting.exception.SHRWebException;
import com.kingdee.util.DateTimeUtils;
import org.apache.log4j.Logger;

import java.text.ParseException;
import java.util.Calendar;
import java.util.Date;
import java.util.HashSet;
import java.util.Set;

public class RoomChangeApplicationControllerBean extends AbstractRoomChangeApplicationControllerBean {
    private static Logger logger = Logger.getLogger(RoomChangeApplicationControllerBean.class);

    @Override
    protected void _submitEffect(Context ctx, String billId) throws BOSException, EASBizException {
        super._submitEffect(ctx, billId);
        RoomChangeApplicationInfo roomChangeApplicationInfo = this.getRoomChangeApplicationInfo(ctx, new ObjectUuidPK(billId));
        this._submitEffect(ctx, roomChangeApplicationInfo);
    }

    /**
     * ύЧ
     *
     * @param ctx
     * @param model
     * @return
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected IObjectPK _submitEffect(
            Context ctx,
            CoreBaseInfo model
    ) throws BOSException, EASBizException {
        logger.error("_submitEffect-----");
        RoomChangeApplicationInfo info = (RoomChangeApplicationInfo) model;
        info = getRoomChangeApplicationInfo(ctx, new ObjectUuidPK(info.getId()));
        //ԱסϢ
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        //ԱסϢ޸ֶ
        SelectorItemCollection sicOccupants = new SelectorItemCollection();
        sicOccupants.add("CheckOutDate");
        //޵¼
        SelectorItemCollection sicEntry = new SelectorItemCollection();
        sicEntry.add("occupants");
        //סԱϢ
        for (int i = 0; i < info.getEntrys().size(); i++) {
            RoomChangeApplicationEntryInfo entryInfo = info.getEntrys().get(i);
            //ԭסԱϢ
            OccupantsInfo oldOccupants = entryInfo.getOldOccupants();
            //ԭ
            entryInfo.setOldCheckoutDate(oldOccupants.getCheckOutDate());
            //µסԱϢ
            oldOccupants = iOccupants.getOccupantsInfo(new ObjectUuidPK(oldOccupants.getId()));
            //޸ԭסԱϢʱڻ޵סʱǰһ졣
            Date checkInDate = entryInfo.getCheckInDate();
            oldOccupants.setCheckOutDate(DateTimeUtils.addDay(checkInDate, -1));
            iOccupants.updatePartial(oldOccupants, sicOccupants);
            //һµԱסϢסʱڻ޵סʱ
            //סԱϢ
            OccupantsInfo occupantsInfo = new OccupantsInfo();
            //סԱ
            occupantsInfo.setPerson(entryInfo.getPerson());
            //ס
            occupantsInfo.setCheckInDate(entryInfo.getCheckInDate());
            //
            occupantsInfo.setCheckOutDate(entryInfo.getCheckoutDate());
            //ס
            occupantsInfo.setDormitory(entryInfo.getAdjustRoom());
            //Ա
            occupantsInfo.setPersonDormitoryType(oldOccupants.getPersonDormitoryType());
            //
            //occupantsInfo.setDormitory(oldOccupants.getDormitory());
            //ְλ
            occupantsInfo.setPersonPosition(oldOccupants.getPersonPosition());
            //occupantsInfo.setPersonD
            //״̬:
            //occupantsInfo.setState(BasicItemStateEnum.ENABLE);
            iOccupants.addnew(occupantsInfo);
            // µסԱϢ
            entryInfo.setOccupants(occupantsInfo);

        }
        update(ctx, new ObjectUuidPK(info.getId()), info);
        IObjectPK iObjectPK = super._submitEffect(ctx, info);
        //УʱǷڽ
        return iObjectPK;
    }


    /**
     * 
     *
     * @param ctx
     * @param billId
     * @throws BOSException
     * @throws EASBizException
     */
    @Override
    protected void _untiCheckBizBill(
            Context ctx,
            String billId
    ) throws BOSException, EASBizException {
        super._untiCheckBizBill(ctx, billId);
        IRoomChangeApplicationEntry iEntry = RoomChangeApplicationEntryFactory.getLocalInstance(ctx);
        //ԱסϢ
        IOccupants iOccupants = OccupantsFactory.getLocalInstance(ctx);
        //޵
        RoomChangeApplicationInfo roomChangeApplicationInfo = this.getRoomChangeApplicationInfo(ctx, new ObjectUuidPK(billId));
        RoomChangeApplicationEntryCollection entrys = roomChangeApplicationInfo.getEntrys();
        //ԱסϢ޸ֶ
        SelectorItemCollection sicOccupants = new SelectorItemCollection();
        sicOccupants.add("CheckOutDate");
        for (int i = 0; i < entrys.size(); i++) {
            RoomChangeApplicationEntryInfo roomChangeApplicationEntryInfo = entrys.get(i);
            //סԱϢ
            OccupantsInfo occupants = roomChangeApplicationEntryInfo.getOccupants();
            //ɾ
            iOccupants.delete(new ObjectUuidPK(occupants.getId()));
            //ԭסԱϢ
            OccupantsInfo oldOccupants = roomChangeApplicationEntryInfo.getOldOccupants();
            try {
                oldOccupants.setCheckOutDate(DateTimeUtils.parseDate("2199-12-31", "yyyy-MM-dd"));
            } catch (ParseException e) {
                throw new RuntimeException(e);
            }
            //oldOccupants.setCheckOutDate(roomChangeApplicationEntryInfo.getOldCheckoutDate());
            iOccupants.updatePartial(oldOccupants, sicOccupants);
            //ԭסϢ ԭ
            roomChangeApplicationEntryInfo.setOccupants(null);
            iEntry.update(new ObjectUuidPK(roomChangeApplicationEntryInfo.getId()), roomChangeApplicationEntryInfo);
        }
    }
}
