package com.kingdee.eas.custom.synctask.util;

import okhttp3.*;
import org.apache.log4j.Logger;
import java.io.IOException;
import java.security.MessageDigest;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import com.alibaba.fastjson.JSONObject;

public class HttpClientUtil {
    private static final Logger logger = Logger.getLogger(HttpClientUtil.class);
    private static final OkHttpClient client = new OkHttpClient.Builder()
            .connectTimeout(30, TimeUnit.SECONDS)
            .readTimeout(30, TimeUnit.SECONDS)
            .build();

    /**
     *  POST JSON ʽ
     * @param urlPath   ӿڵַɺ· `/api/v2/transaction/get`
     * @param params    JSON 
     * @param queryParams URL ѯ `timestamp`  `token`
     * @return Ӧַʧܷ null
     */
    public static String sendPostRequest(String urlPath, JSONObject params, Map<String, String> queryParams) {
        try {
            // 1.  URLѯ
            HttpUrl.Builder urlBuilder = HttpUrl.parse(urlPath).newBuilder();
            if (queryParams != null) {
                queryParams.forEach(urlBuilder::addQueryParameter);
            }
            String fullUrl = urlBuilder.build().toString();

            // 2. 
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, params.toJSONString());

            // 3. 
            Request request = new Request.Builder()
                    .url(fullUrl)
                    .post(body)
                    .addHeader("Content-Type", "application/json")
                    .build();

            // 4. 󲢴Ӧ
            try (Response response = client.newCall(request).execute()) {
                if (response.isSuccessful() && response.body() != null) {
                    return response.body().string();
                } else {
                    logger.error("ʧܣ״̬: " + response.code());
                }
            }
        } catch (IOException e) {
            logger.error("쳣: " + e.getMessage(), e);
        }
        return null;
    }


}